	.286
cseg	segment
	assume	cs:cseg,ss:cseg,ds:cseg
	org	80h
command_line_length	label	byte
	org	81h
command_line	label	byte
	org	100h
start:	jmp	main

save_r  proc    near		; p pp
	push    bp		; AX,BX,CX,DX,SI,DI,BP
	mov     bp,sp
	mov     bp,[bp+2]
	push    ax
	push    bx
	push    cx
	push    dx
	push    di
	push    si
	push    bp
	mov     bp,sp
	mov     bp,[bp+14]
	ret
save_r  endp

ret_r   proc    near		; ⠭ pp
	pop     ax		; AX,BX,CX,DX,SI,DI,BP
	mov	bp,sp
	mov	[bp+14],ax
	pop     si
	pop     di
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	pop     bp
	ret
ret_r   endp	    

Initialize	proc	near
	cld

	mov	ah,1ah		; ⠭ p DTA
	lea	dx,DTA
	int	21h
	
	mov	ax,10h
	int	10h
	ret
Initialize	endp

get_pcx_name	proc	near
	cmp	file_name,0
	jnz	gpn2

	mov	ah,4eh		; find first
	lea	dx,pcx_fspec
	mov	cx,20h
	jmp	gpn3

gpn2:	mov	ah,4fh		; find next
	lea	dx,DTA

gpn3:	int	21h
	jnc	gpn_ex

gpn_ex:	lea	si,pcx_fspec
	lea	di,file_name

lpf7:	lodsb			; p뫪  
	cmp	al,'*'		; pcx_fspec  file_name
	je	lpf8
	stosb
	jmp	lpf7
	
lpf8:	lea	si,DTA
	add	si,30		; si -> DTA [file_name]
	mov	cx,13
	rep	movsb		; p뫪  䠩

	ret
get_pcx_name	endp

example	proc	near
	call	save_r

again:	call	get_pcx_name
	jc	example1

	call	Next_file

	cmp	error_flag,0
	jnz	example1

	call	pcxout

	mov	ah,1	; 室, ᫨   <Esc>
	int	16h
	jz	m99
	mov	ah,0
	int	16h
	cmp	al,1bh
	jne	m99
	jmp	example1
	
m99:	mov	ah,3eh
	mov	bx,fm
	int	21h
	jmp	again

example1:
	mov	ah,3eh
	mov	bx,fm
	int	21h
	call	ret_r
	ret
example	endp

Next_file	proc	near
	lea	dx,file_name
	mov	ax,3d00h
	int	21h
	jnc	nf1
	mov	error_flag,1
	ret

nf1:	mov	fm,ax
	mov	ah,3fh
	lea	dx,PCX_Head
	mov	cx,length PCX_Buffer
	add	cx,128
	mov	bx,fm
	int	21h
	ret
Next_file	endp

set_bit_maska	proc	near
; al - maska
	push	dx		; ⠭ ᪠ ⮢,
	push	ax		;   al
	mov	dx,3ceh
	mov	al,8
	out	dx,al
	inc	dx
	pop	ax
	out	dx,al
	pop	dx
	ret
set_bit_maska	endp

clr	proc    near		; ⠭
	mov	al,5		; p  0  ⥭ 0
	mov	dx,3ceh
	out	dx,al
	inc	dx
	mov	al,0
	out	dx,al

	mov     al,8
	mov     dx,3ceh		; ᪠ ⮢ = 0ffh
	out     dx,al
	inc     dx
	mov     al,0ffh
	out     dx,al

	mov     al,2
	mov     dx,3c4h		; ᪠ p = 0ffh
	out     dx,al
	inc     dx
	mov     al,0ffh
	out     dx,al
	ret
clr	endp

test_of_read_next_part	proc	near
	push	ax
	lea	ax,PCX_Buffer
	add	ax,length PCX_Buffer
	cmp	si,ax
	jb	rnp

	call	save_r

	mov	cx,length PCX_Buffer ; ᨬ쭠 
	lea	dx,PCX_Buffer
	mov	ah,3fh
	mov	bx,fm
	int	21h		; p㧪  PCX-䠩

	call	ret_r
	lea	si,PCX_Buffer

rnp:	pop	ax
	ret
test_of_read_next_part	endp

regs_load	proc	near
;	(bl):=bh
	push	ax		; p楤p  p㧪
	push	dx		; pp p (p bl)
	mov	dx,3dah		;  梥  bh
	in	al,dx
	mov	al,bl
	mov	dx,3c0h
	out	dx,al
	mov	al,bh
	out	dx,al	
	mov	dx,3dah
	in	al,dx
	mov	dx,3c0h
	mov	al,20h
	out	dx,al	
	pop	dx
	pop	ax
	ret
regs_load	endp

palette_decoding	proc	near
	pusha

	lea	si,PCX_Head
	add	si,16		; si - p p  

	mov	cx,16		; pp p 
	xor	bl,bl		; ⥪饩 p⨭  
palloop:
	xor	bh,bh		;  R - 
	lodsb
	test	al,40h		; p 6-  7- 
	jz	pal1
	or	bh,20h		; ⠭ r
pal1:	test	al,80h
	jz	pal2
	or	bh,4		; ⠭ R
pal2:	lodsb			;  G - 
	test	al,40h
	jz	pal3
	or	bh,10h		; ⠭ g
pal3:	test	al,80h
	jz	pal4
	or	bh,2		; ⠭ G
pal4:	lodsb			;  B - 
	test	al,40h
	jz	pal5
	or	bh,8		; ⠭ b
pal5:	test	al,80h
	jz	pal6
	or	bh,1		; ⠭ B
	
pal6:	call	regs_load	; p㧪 p pp
	inc	bl		; p
	loop	palloop

	popa
	ret
palette_decoding	endp

pcxout	proc	near
	call	save_r
	push	es

	call	clr
	
	call	palette_decoding

	mov	dx,page_addr
	mov	es,dx		; p p

	lea	bx,PCX_Head	;  bx p  PCX-䠩

	mov	ax,maxY		; ᫥ pp
	cmp	[bx+10],ax
	jle	cont33
	mov	[bx+10],ax
	jmp	cont44

cont33:	mov	ax,[bx+10]
cont44:	mov	ax,[bx+4]
	and	al,7
	mov	DeltaB1,al	; DeltaB1:=Xmin mod 8

	mov	ax,[bx+8]
	not	al
	and	al,7
	mov	DeltaB2,al	; DeltaB2:=(7-Xmax) mod 8

	mov	al,0ffh
	mov	cl,DeltaB1
	shr	al,cl
	mov	MaskaLeft,al	; MaskaLeft:=(00..01..11)
				;	      
	mov	al,0ffh		;	     DeltaB1
	mov	cl,DeltaB2
	shl	al,cl
	mov	MaskaRight,al	; MaskaRight:=(11..100..0)
				;		    
	mov	ax,[bx+4]	;		   DeltaB2
	mov	cl,3
	shr	ax,cl
	mov	ah,al		; p   p⨭  ah
	mov	LeftByte,al	; ᫮  ⮢ ᫥ ([Xmin/8])

	mov	dx,[bx+8]
	mov	cl,3
	shr	dx,cl		; RightByte
	xor	dh,dh		; ᫨ p  p  
	sub	dl,al		; p ⮢ p⨭  
	cmp	dx,[bx+66]	; /,  
	jl	cont88		; Bytes:=/,
	mov	dx,[bx+66]
	jmp	cont888
cont88:	inc	dl		;  Bytes:=᫮  p
cont888: mov	Bytes,dl	;    p  (-)

;------------------------------
;	cl - current_card
;	ch - current_byte_count
;	ah - current_byte
;	si - RunLenght_Data
;	bp - BytePerLine
;	Maska_flag - maska_flag
;	Plus_current_x - current_x
	lea	si,PCX_Buffer	; 砫 p 

	mov	bp,[bx+66]	; BytePerLine
	mov	di,[bx+6]	; Ymin
	mov	cl,4
	shl	di,cl
	mov	ax,di
	shl	di,1
	shl	di,1
	add	di,ax
	mov	al,LeftByte
	xor	ah,ah
	add	di,ax		; 80*Ymin+LeftByte

	xor	cx,cx		; current_byte_count & current_card
	mov	ax,[bx+6]
	mov	Plus_current_y,ax
	jmp	kk21

kk1:	inc	cl		; ᫥ p
	cmp	cl,4
	jne	kk2
	xor	cl,cl
	inc	Plus_current_y
	push	ax
	mov	ax,Plus_current_y
	cmp	ax,[bx+10]
	pop	ax
	jbe	kk11		; 
	jmp	kk5

kk11:	add	di,80
kk2:	mov	al,2		; ᪠ p
	mov	dx,3c4h
	out	dx,al
	inc	dx
	mov	al,1
	shl	al,cl
	out	dx,al

	sub	di,bp		;  ᫮   

kk21:	mov	al,MaskaLeft ; ᪠ ⮢     p
	call	set_bit_maska

	mov	Plus_current_x,0 ; current_x
	mov	Maska_flag,0	; 䫠  ⠭ ᪨
	jmp	next_byte

kk3:	mov	al,0ffh		;  ᪠ ⮢  'p' 
	call	set_bit_maska
	jmp	next_byte

kk4:	mov	al,MaskaRight	; ᪠ ⮢  p   p
	call	set_bit_maska

next_byte:
	cmp	ch,0		; current_byte_count
	jne	next_ex

	call	test_of_read_next_part
	lodsb			;  al ᫥騩 RunLength - 

	cmp	al,0c0h		; ᫨ 7-  6-  ⠭,
	jnb	nm2		;     (᫠ p
				; ᫥饣  ( ))
nm1:	mov	ah,al		;   
	mov	ch,1		;  
	jmp	next_ex

nm2:	and	al,3fh		;    (   6 )
	mov	ch,al		; ⮫쪮 p

	call	test_of_read_next_part
	lodsb			;  al ᫥騩 RunLength - 

	mov	ah,al		; p塞  

next_ex:
	mov	al,es:[di]	; p㧪 pp 
	mov	al,ah		;  
	stosb			;  ᫥饣   -

	dec	ch		; dec current_byte_count
	inc	Plus_current_x	; current_x

	mov	dl,Plus_current_x
	inc	dl
	cmp	dl,Bytes	; Bytes
	je	kk4
	jb	kk44

	mov	al,0
	call	set_bit_maska

kk44:	cmp	dl,[bx+66]	; BytePerLine
	jbe	kk45
	jmp	kk1

kk45:	cmp	Maska_flag,0
	jne	next_byte

	inc	Maska_flag
	jmp	kk3

kk5:	mov	al,0ffh
	call	set_bit_maska

	pop	es
	call	ret_r
	ret
pcxout	endp

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;----------------------- M A I N -- P R O G R A M -----------------------------
;------------------------------------------------------------------------------
main:	call	Initialize

	call	example

exit:	mov	ax,3
	int	10h

	int	20h	; QUIT

;------------------------------ D A T A ---------------------------------------
; ᭮   pp
;---------------------------- p㣨  -----------------------------------
; p  裡  譨 p (᪮)
DTA		db	43 dup(?)
file_name	db	40h dup(?)
pcx_fspec	db	'\pbrush\pcx\engl_pcx\*.pcx',0
fm	dw	?
error_flag	db	0

; p p  p᪮ 뢮
maxX	equ	639
maxY	equ	349
page_addr	dw	0a000h

; After PCXOut
DeltaX		dw	(?)
DeltaY		dw	(?)
DeltaB1		db	(?)
DeltaB2		db	(?)
LeftByte	db	(?)
Bytes		db	(?)
RightByte	db	(?)
MaskaLeft	db	(?)
MaskaMedium	db	0ffh
MaskaRight	db	(?)
; ᯮ⥫ p
Plus_current_x	db	?
Plus_current_y	dw	?
Maska_flag	db	?

;---------------------------- DIFFERENT BUFFERS -------------------------------
;----------------------------- PCX-data buffer --------------------------------
;	Begin(3db),Bits(db),Xmin(dw),Ymin(dw),Xmax(dw),Ymax(dw)
;	HRes(dw),VRes(dw),Palette(16*3db),db,Planes(db)
;	BytePerLine(dw),PaletteInfo(dw)
PCX_Head	db	128 dup(?)	;  PCX-䠩
PCX_Buffer	db	60000 dup(?)	; p 뢠 䠩
cseg	ends
	end	start
