;
;	This program writted for PCX-service.
;
; Printer mode 3 (1920   pp)
;--------------------------------
;	CODE
;--------------------------------
cseg	segment
	assume	cs:cseg,ds:cseg,ss:cseg,es:cseg
	org	80h
command_line_length	label	byte
	org	81h
command_line	label	byte
	org	100h
start:	jmp	main

save_r  proc    near		; p pp
	push    bp		; AX,BX,CX,DX,SI,DI,BP
	mov     bp,sp
	mov     bp,[bp+2]
	push    ax
	push    bx
	push    cx
	push    dx
	push    di
	push    si
	push    bp
	mov     bp,sp
	mov     bp,[bp+14]
	ret
save_r  endp

ret_r   proc    near		; ⠭ pp
	pop     ax		; AX,BX,CX,DX,SI,DI,BP
	mov	bp,sp
	mov	[bp+14],ax
	pop     si
	pop     di
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	pop     bp
	ret
ret_r   endp	    

Read_options	proc	near
	mov	cl,option_number
	xor	ch,ch

to1:	push	cx
	xor	di,di
	xor	dx,dx
	xor	ah,ah
	mov	bl,option_number
	xor	bh,bh
	sub	bx,cx
	shl	bx,1
	mov	bx,[option_addresses+bx]
	lea	si,command_line
	mov	cl,command_line_length
	inc	cl
	xor	ch,ch

to11:	lodsb
	cmp	byte ptr [bx+di],'$'
	je	next_number
	cmp	al,[bx+di]
	je	to2
	cmp	byte ptr [bx+di],'A'
	jb	to21
	cmp	byte ptr [bx+di],'Z'
	ja	to21
	sub	al,'a'-'A'
	cmp	al,[bx+di]
	je	to2
to21:	xor	di,di
	jmp	to3
to2:	inc	di
	jmp	to3

next_number:
	cmp	al,'0'
	jb	to4
	cmp	al,'9'
	ja	to4

	push	ax
	shl	dx,1
	mov	ax,dx
	shl	dx,1
	shl	dx,1
	add	dx,ax
	pop	ax

	sub	al,'0'
	add	dx,ax
	jmp	to3

to4:	mov	di,[bx+di+1]
	or	dx,dx
	jnz	to5
	inc	dx
	
to5:	mov	[di],dx
	mov	cx,1
to3:	loop	to11

	pop	cx
	loop	to1
	ret
Read_options	endp

File_open	proc	near
	mov	cl,command_line_length
	xor	ch,ch
	lea	si,command_line
	xor	ah,ah
	
fo1:	lodsb
	or	ah,ah
	jnz	fo2
	cmp	al,' '
	je	fo3
	inc	ah
	mov	dx,si
	dec	dx
	jmp	fo3

fo2:	cmp	al,' '
	je	fo4
	cmp	al,'/'
	jne	fo3
fo4:	dec	si
	mov	cx,1
fo3:	loop	fo1

	mov	byte ptr [si],0
	mov	ax,3d00h
	int	21h
	jnc	fo5

	mov	al,2
	call	message
	int	20h

fo5:	mov	fm,ax
	ret
File_open	endp

Palette_gradation	proc	near
	mov	bx,fm
	mov	ax,4202h
	xor	cx,cx
	xor	dx,dx
	int	21h
	
	sub	ax,256*3
	sbb	dx,0
	mov	cx,dx
	mov	dx,ax
	mov	ax,4200h
	int	21h
	
	mov	ah,3fh
	mov	cx,256*3
	lea	dx,Palette
	int	21h
	
	lea	di,Palette	; 
	mov	si,di
	mov	cx,256
	
l:	push	cx
	xor	ah,ah
	lodsb
	and	al,0fch
	mov	bx,ax
	lodsb
	and	al,0fch
	add	bx,ax
	lodsb
	and	al,0fch
	add	bx,ax
	mov	ax,bx
	mov	bl,15
	div	bl
	shr	al,1
	and	al,0feh
	stosb
	pop	cx
	loop	l

	mov	bx,fm
	mov	ax,4200h
	xor	cx,cx
	xor	dx,dx
	int	21h
	
	ret
Palette_gradation	endp

Initialize      proc    near
	cld			; p 䫠  楯 p権
	mov	al,0
	call	message

	cmp	command_line_length,1
	jle	i3

	call	Read_options
	cmp	Help_flag,1
	je	i3

	call	File_open
	call	Palette_gradation
	jmp	i2

i3:	mov	al,1
	call	message
	int	20h

i2:	lea	dx,graph
	call	out_str

	mov	bx,fm
	mov	cx,128		; ⥭ 
	mov	ah,3fh		; PCX - 䠩
	lea	dx,Begin
	int	21h

	cmp	X,-1
	jne	i4
	mov	ax,word ptr Begin[4]
	mov	X,ax
	
i4:	cmp	Y,-1
	jne	i5
	mov	ax,word ptr Begin[6]
	mov	Y,ax
	
i5:	mov	ax,word ptr SY
	mov	dx,Y
	mul	dx
	mov	bx,ax		; p塞 Y*SY  bx
	shr	ax,cl		; p p pp ((Y*SY) div 8) p
	
	or	ax,ax
	jz	i6
	mov	cx,ax
	
i7:	mov	ah,5
	mov	al,10
	call	print_symbol
	loop	i7
	
i6:	mov	ax,bx
	and	al,7
	mov	dl,al
	shl	dl,1
	add	dl,al		;  dl 室 ᫮ (Y*SY mod 8)*3
	
	mov	ax,4a1bh	; pp  p⨪  Ymin
	call	pr2bs
	mov	al,dl
	xor	ah,ah
	call	pr2bs

	mov	ax,word ptr Begin[8]
	sub	ax,word ptr Begin[4]
	sub	ax,DX		; Xmax - Xmin - DX
	cmp	LX,0
	jz	i8
	
	cmp	LX,ax
	jle	i9
	
i8:	mov	LX,ax
	
i9:	mov	ax,word ptr Begin[10]
	sub	ax,word ptr Begin[6]
	sub	ax,DY		; Ymax - Ymin - DY
	inc	ax
	cmp	LY,0
	jz	i10
	
	cmp	LY,ax
	jle	i11
	
i10:	mov	LY,ax
	
i11:	mov	ax,X
	add	ax,LX
	mov	dx,word ptr SX
	mul	dx
shr	ax,1
	mov	Prn_length,ax
	mov	ax,LX
	mov	dx,word ptr SX
	mul	dx
	mov	LX_Prn,ax
	
	mov	ax,X
	mov	dx,word ptr SX
	mul	dx
	mov	Prn_clear_bytes_number,ax
	lea	bx,Prn_String
	xor	al,al
	mov	di,bx
	mov	cx,Prn_clear_bytes_number
	rep	stosb

	mov	ax,LY
	mov	dx,word ptr SY
	mul	dx
	dec	ax
	mov	cl,3
	shr	ax,cl
	inc	ax
	mov	Prn_strings_number,ax	; (((LY*SY-1) div 8)+1)

	lea	si,RunLength_Data
	mov	al,4
	call	message

	mov	ah,3
	xor	bh,bh
	int	10h
	dec	dh
	mov	Percents_y,dh

nn2:	mov	bx,fm
	mov	cx,length RunLength_Data ; ⥭ 1-  䠩
	mov	ah,3fh
	lea	dx,RunLength_Data
	int	21h

	mov	ax,word ptr Begin[10]
	sub	ax,word ptr Begin[6]
	inc	ax
	mov	word ptr Begin[10],ax	; pp p㭪  Y
		
	mov	cx,DY
	or	cx,cx
	jz	in_ex
	
str_offset:
	call	next_PCX_string
	loop	str_offset

in_ex:	ret
Initialize      endp

Return	proc	near
	mov	bx,fm		; p⨥ 䠩
	mov	ah,3eh
	int	21h

	lea	dx,ret_prn
	call	out_str

	int	20h		; p襭 pp
Return	endp

message	proc	near
;	this procedure print error-message with number AL
	call	save_r

	lea	si,messages_addresses
	xor	ah,ah
	shl	ax,1
	add	si,ax
	mov	si,[si]
	lodsb
	mov	bl,al		; p
	mov	ah,9
	xor	bh,bh
	
mm1:	lodsb
	cmp	al,'$'
	jz	mm2
	cmp	al,10
	je	mm3
	cmp	al,13
	jne	mm4
mm3:	mov	ah,0eh
	int	10h
	jmp	mm1

mm4:	mov	ah,9
	mov	cx,1
	int	10h
	mov	ah,3
	int	10h
	inc	dl
	mov	ah,2
	int	10h
	jmp	mm1

mm2:	call	ret_r
	ret
message	endp

out_percents	proc	near
	mov	ah,2
	mov	dl,Percents_x
	mov	dh,Percents_y
	xor	bh,bh
	int	10h
	mov	ax,Prn_string
	mov	dx,100
	mul	dx
	mov	cx,Prn_strings_number
	div	cx
	cmp	dx,cx
	jl	op1
	inc	ax
op1:	mov	dl,10
	mov	bl,15
	
op2:	or	ax,ax
	jz	op3

	div	dl
	push	ax
	push	dx
	mov	al,ah
	add	al,30h
	mov	ah,9
	mov	cx,1
	int	10h

	mov	ah,3
	int	10h

	dec	dl
	mov	ah,2
	int	10h

	pop	dx
	pop	ax
	xor	ah,ah
	jmp	op2

op3:	mov	ah,3
	int	10h

	mov	dl,80
	mov	ah,2
	int	10h
	ret
out_percents	endp
	
out_str	proc	near
;	dx - address of data (end - '$')
	push	dx
	push	si
	push	ax
	mov	ah,5
	mov	si,dx
	xor	dx,dx

os2:	lodsb
	cmp	al,'$'
	je	os1
	call	print_symbol
	jmp	os2
	
os1:	pop	ax
	pop	si
	pop	dx
	ret
out_str	endp

pr2bs	proc	near
; 뢮  pp al,ah
	push	dx
	push	ax
	mov	dh,ah
	call	print_symbol
	mov	al,dh
	call	print_symbol
	pop	ax
	pop	dx
	ret
pr2bs	endp

test_of_read_next_part	proc	near
	cmp	si,offset End_RunLength_Data
	jb	tornp_ex

	call	save_r
	mov	bx,fm
	mov	cx,length RunLength_Data ;  p
	mov	ah,3fh
	lea	dx,RunLength_Data
	int	21h		; p㧪  PCX-䠩
	call	ret_r		; ᫥. p樨 

	lea	si,RunLength_Data

tornp_ex:
	ret
test_of_read_next_part	endp

next_PCX_string	proc	near
;	si - address in RunLength_Data
	push	ax
	push	cx
	push	si
	push	di
	lea	di,PCX_String
	mov	cx,word ptr Begin[66]
	mov	ax,PCX_str_num
	cmp	ax,word ptr Begin[10]
	jl	next1
	jmp	quit
	
next1:	mov	si,current_RLC_address
	mov	ax,current_RLC_byte

next_byte:
	cmp	ah,0	; current_byte_count
	jne	next_ex
	call	test_of_read_next_part
	lodsb			;  al ᫥騩 RunLength - 
	cmp	al,0c0h		; ᫨ 7-  6-  ⠭,
	jnb	nm2		;     (᫠ p
				; ᫥饣  ( ))
nm1:	mov	ah,1		;   ,  
	jmp	next_ex

nm2:	and	al,3fh		;    (   6 )
	mov	ah,al		; ⮫쪮 p
	call	test_of_read_next_part
	lodsb			; p塞    al

next_ex:
	stosb			;  ᫥饣   PCX_String
	dec	ah		; dec current_byte_count
	loop	next_byte
	
	mov	current_RLC_byte,ax
	mov	current_RLC_address,si
	inc	PCX_str_num

np_ex:	pop	di
	pop	si
	pop	cx
	pop	ax
	ret
next_PCX_string	endp

print_symbol	proc	near
;	al - symbol_code
	push	cx
	push	dx
	xor	dx,dx

ps1:	mov	ah,2
	int	17h
	cmp	ah,10h
	je	ps2
	test	ah,08h
	jnz	ps2
	cmp	ah,30h
	je	ps2
	
	mov	ah,0
	int	17h

	pop	dx
	pop	cx
	ret

ps2:	push	ax
	mov	ah,1
	int	16h
	jz	ps4
	mov	ah,0
	int	16h
	cmp	al,1bh
	jnz	ps4
	jmp	quit

ps4:	pop	ax
	jmp	ps1

print_symbol	endp

;------------------------------------------------------------------------------
;			  This is a major PCX-program
;------------------------------------------------------------------------------
main:	call	Initialize

	mov	cx,Prn_strings_number
	
next_prn_string:
	push	cx
	mov	cx,4

fill_next_prn_stringty:
	push	cx
	lea	bx,Prn_String
	cmp	load_next_PCX_string?,0
	jnz	no_load
	
	call	next_PCX_string
	
no_load:
	mov	di,Prn_clear_bytes_number
	mov	dx,DX_		; current_x
	mov	cx,LX
	
move_string:
	push	cx	
	lea	si,PCX_String
	add	si,dx
	xor	ah,ah
	lodsb
	lea	si,Palette
	add	si,ax
	lodsb
	lea	si,prn_colors_equ
	add	si,ax
	lodsb
	test	load_next_PCX_string?,1
	jz	n1
	lodsb

n1:	push	dx
	mov	dl,al
	xor	ch,ch
	
next_prn_point:
	mov	cl,ch
	and	cl,7
	cmp	cl,6
	jl	npp1
	sub	cl,6

npp1:	mov	al,dl			; cl = (0,1,2)
	shr	al,cl
	cmp	Inverse_flag,0
	jnz	no_xor
	xor	al,1

no_xor:	and	al,1			;  襬  al 梥 窨
	mov	ah,[bx+di]
	shl	ah,1
	or	ah,al
	shl	ah,1
	mov	[bx+di],ah
	inc	di
	inc	ch
	cmp	ch,SX
	jl	next_prn_point
	
	pop	dx
	inc	dx
	pop	cx
	loop	move_string
	
	inc	load_next_PCX_string?
	mov	al,SY
	cmp	load_next_PCX_string?,al
	jl	?increment
	sub	load_next_PCX_string?,al
	
?increment:	
	pop	cx
	loop	l_01
	jmp	print
	
l_01:	jmp	fill_next_prn_stringty
	
;------ 뢮 ᫥饩 p  pp ------
print:	lea	bx,Prn_String
	mov	cx,word ptr Number_of_go

next_go:
	push	cx	; 横   室

	mov	ah,1	; 室, ᫨   <Esc>
	int	16h
	jz	m99
	cmp	al,1bh
	jne	m99
	jmp	quit

m99:	mov	si,bx
	lea	dx,Prn_letter
	call	out_str
	mov	cx,Prn_length

next_prn_byte:
	lodsb
	call	print_symbol
	loop	next_prn_byte

	mov	al,13		; 
	call	print_symbol
	
	pop	cx
	loop	next_go
	
	mov	al,10		; 
	call	print_symbol

	inc	Prn_string
	call	out_percents
	pop	cx
	loop	l_00

	mov	ax,0e07h
	int	10h

quit:	mov	al,5
	call	message
	call	Return		; QUIT

l_00:	jmp	next_prn_string
;------------------------------------------------------------------------------
;				   DATA
;------------------------------------------------------------------------------
messages_addresses	dw	head_msg,hlp_msg,err_msg
	dw	0,prtd_msg,cr,0,0,0
head_msg	db 15,'The PCX-Printer, Version 1.1, Copyright (C) '
		db '1993 by Kalinin E.A., Polygon Ltd.',10,13,'$'
hlp_msg	db 7,'ଠ ᪠ :    VGA2PRN [ 䠩] [/] [/..]',10,13
	db '樨 :   /?,/H            ଠ樨  ࠭,',10,13
	db '          /Nn            ᫮ 室,',10,13
	db '          /Xmmm,/Ynnn    p ᬥ饭  pp p'
	db ' 砫',10,13,25 dup(20h)
	db ' ( 㬮砭: X,Y   PCX-䠩),',10,13
	db '          /DXmmm,/DYnnn  ᬥ饭  X  Y pᯥ뢠  '
	db 'p',10,13,25 dup(20h)
	db '(PCX-䠩) ⭮⥫쭮   p孥 窨,',10,13
	db '          /LXmmm,/LYnnn  pp  X  Y pᯥ뢠  '
	db 'p',10,13,25 dup(20h)
	db '( 㬮砭   p p  ᭨),',10,13
	db '          /SXm,/SYn      蠣 p⭮ ⪨ pp  X  Y '
	db 10,13,25 dup(20h),'( 㬮砭 6  2),',10,13
	db '          /I             p 뢮   p.'
	db 10,13
	db ' 砭  VGA2PRN ந 㪮 ᨣ.',10,13
	db ' ਩ 室  ணࠬ  襩 <Esc>.'
	db 10,13,'$'
err_msg	db 8fh,'ࠢ쭮  䠩 !',10,13,'$'
prtd_msg	db 7,'뢥     0% 䠩.',10,13,'$'
cr		db 3,10,13,'$'

Percents_x	db	21
Percents_y	db	?

;------------------------------------------------------------------------------
option_number	db	12
option_addresses	dw	optN,optH,opt?,optInv,optX,optY
			dw	optDX,optDY,optLX,optLY,optSX,optSY
optN	db	'/N$'
	dw	Number_of_go
optH	db	'/H$'
	dw	Help_flag
opt?	db	'/?$'
	dw	Help_flag
optInv	db	'/I$'
	dw	Inverse_flag
optX	db	'/X$'
	dw	X
optY	db	'/Y$'
	dw	Y
optDX	db	'/DX$'
	dw	DX_
optDY	db	'/DY$'
	dw	DY
optLX	db	'/LX$'
	dw	LX
optLY	db	'/LY$'
	dw	LY
optSX	db	'/SX$'
	dw	SX
optSY	db	'/SY$'
	dw	SY

;- pp,    p -
Help_flag	db	0,0
Number_of_go	db	1,0
Inverse_flag	db	0,0
X	dw	-1
Y	dw	-1
DX_	dw	0
DY	dw	0
LX	dw	0
LY	dw	0
SX	db	6,0
SY	db	2,0

prn_colors_equ	dw	0,400h,1002h,1104h,1209h,2912h,2a15h
		dw	2b15h,2b35h,3b35h,3b37h,3f37h,3f3fh

graph	db	13	; ⪠ p pp ()
	db	27,64	; 樠 ਭ
	db	27,65
	db	8	; 8/72   p
	db	'$'

ret_prn	db	27,64	; 樠 ਭ
;	db	12	; ண  ()
	db	'$'

;---------- p   -----------
load_next_PCX_string?	db	0
LX_Prn		dw	?
Prn_clear_bytes_number	dw	?
Prn_string	dw	?
Prn_strings_number	dw	?
PCX_str_num	dw	0

;-------- p  RL-decoding ---------
current_RLC_address	dw	RunLength_Data
current_RLC_byte	dw	0

;----------------- PCX-data ------------------
fm	dw	?
Begin	db	128 dup(?)
Palette	db	256*3 dup(?)

;---------- p  p p ----------
PCX_String	db	320 dup(?)

;------- 뫪 p. p.  pp -------
Prn_letter	db	1bh,2ah,0
Prn_length	dw	?
	db	'$'
;--------- p  p pp ---------
Prn_String	db	1920 dup(?)

RunLength_Data	db	30000 dup(?)	; 䠩 p
End_RunLength_Data	label	byte
cseg	ends
	end	start
